Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# CORBA_AbstractBase Class Reference

Abstract base class for Interfaces and Valuetypes. More...

`#include <AbstractBase.h>`

Collaboration diagram for CORBA_AbstractBase:

[legend]
List of all members.

## Public Types
typedef CORBA_AbstractBase_ptr | _ptr_type
typedef CORBA_AbstractBase_var | _var_type
## Public Methods
CORBA::Object_ptr | _to_object (void)
CORBA::ValueBase * | _to_value (void)
virtual CORBA::Boolean | _is_a (const char *type_id ACE_ENV_ARG_DECL_WITH_DEFAULTS)
virtual void * | _tao_QueryInterface (ptr_arith_t type)
virtual const char * | _interface_repository_id (void) const
virtual const char * | _tao_obv_repository_id (void) const
virtual void * | _tao_obv_narrow (ptr_arith_t type_id)
virtual CORBA::Boolean | _tao_marshal_v (TAO_OutputCDR &strm)
virtual CORBA::Boolean | _tao_unmarshal_v (TAO_InputCDR &strm)
virtual void | _add_ref (void)
virtual void | _remove_ref (void)
CORBA::Boolean | _is_objref (void) const
TAO_Stub * | _stubobj (void) const
CORBA::Boolean | _is_collocated (void) const
TAO_Abstract_ServantBase * | _servant (void) const
CORBA::Boolean | _is_local (void) const
## Static Public Methods
CORBA::AbstractBase_ptr | _narrow (CORBA::AbstractBase_ptr obj ACE_ENV_ARG_DECL_WITH_DEFAULTS)
| Just call _duplicate and let it decide what to do. More...
CORBA::AbstractBase_ptr | _unchecked_narrow (CORBA::AbstractBase_ptr obj ACE_ENV_ARG_DECL_WITH_DEFAULTS)
| Same for this one. More...
CORBA::AbstractBase_ptr | _duplicate (CORBA::AbstractBase_ptr obj)
CORBA::AbstractBase_ptr | _nil (void)
## Static Public Attributes
int | _tao_class_id = 0
## Protected Methods
| CORBA_AbstractBase (void)
| CORBA_AbstractBase (const CORBA_AbstractBase &)
| CORBA_AbstractBase (TAO_Stub *p, CORBA::Boolean collocated, TAO_Abstract_ServantBase *servant)
virtual | ~CORBA_AbstractBase (void)
## Protected Attributes
CORBA::Boolean | is_objref_
## Private Methods
CORBA_AbstractBase & | operator= (const CORBA_AbstractBase &)
virtual CORBA::ValueBase * | _tao_to_value (void)
## Private Attributes
TAO_Stub * | concrete_stubobj_
CORBA::Boolean | is_collocated_
TAO_Abstract_ServantBase * | servant_
CORBA::Boolean | is_local_
CORBA::ULong | refcount_
| Number of outstanding references to this object. More...
TAO_SYNCH_MUTEX * | refcount_lock_
| This lock is only instantiated for unconstrained objects. More...
## Friends
TAO_Export CORBA::Boolean | operator<< (TAO_OutputCDR &, const CORBA_AbstractBase_ptr)
| So the extraction operator can call the protectec constructor. More...
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &, CORBA_AbstractBase_ptr &)

## Detailed Description

Abstract base class for Interfaces and Valuetypes.

Allows the determination of whether an object has been passed by reference or by value to be deferred until runtime.

## Member Typedef Documentation

typedef CORBA_AbstractBase_ptr CORBA_AbstractBase::_ptr_type

typedef CORBA_AbstractBase_var CORBA_AbstractBase::_var_type

## Constructor & Destructor Documentation

CORBA_AbstractBase::CORBA_AbstractBase | ( | void |  | ) | `[protected]`

CORBA_AbstractBase::CORBA_AbstractBase | ( | const CORBA_AbstractBase & | rhs | ) | `[protected]`

CORBA_AbstractBase::CORBA_AbstractBase | ( | TAO_Stub * | protocol_proxy,
|  | CORBA::Boolean | collocated,
|  | TAO_Abstract_ServantBase * | servant
| ) | `[protected]`

CORBA_AbstractBase::~CORBA_AbstractBase | ( | void |  | ) | `[protected, virtual]`

## Member Function Documentation

void CORBA_AbstractBase::_add_ref | ( | void |  | ) | `[virtual]`

CORBA::AbstractBase_ptr CORBA_AbstractBase::_duplicate | ( | CORBA::AbstractBase_ptr | obj | ) | `[static]`

ACE_INLINE const char * CORBA_AbstractBase::_interface_repository_id | ( | void |  | ) | const`[virtual]`

ACE_INLINE CORBA::Boolean CORBA_AbstractBase::_is_a | ( | const char *type_id | ACE_ENV_ARG_DECL_NOT_USED | ) | `[virtual]`

ACE_INLINE CORBA::Boolean CORBA_AbstractBase::_is_collocated | ( | void |  | ) | const

ACE_INLINE CORBA::Boolean CORBA_AbstractBase::_is_local | ( | void |  | ) | const

ACE_INLINE CORBA::Boolean CORBA_AbstractBase::_is_objref | ( | void |  | ) | const

ACE_INLINE CORBA::AbstractBase_ptr CORBA_AbstractBase::_narrow | ( | CORBA::AbstractBase_ptr obj | ACE_ENV_ARG_DECL_NOT_USED | ) | `[static]`

| Just call _duplicate and let it decide what to do.

ACE_INLINE CORBA::AbstractBase_ptr CORBA_AbstractBase::_nil | ( | void |  | ) | `[static]`

void CORBA_AbstractBase::_remove_ref | ( | void |  | ) | `[virtual]`

ACE_INLINE TAO_Abstract_ServantBase * CORBA_AbstractBase::_servant | ( | void |  | ) | const

ACE_INLINE TAO_Stub * CORBA_AbstractBase::_stubobj | ( | void |  | ) | const

CORBA::Boolean CORBA_AbstractBase::_tao_marshal_v | ( | TAO_OutputCDR & | strm | ) | `[virtual]`

ACE_INLINE void * CORBA_AbstractBase::_tao_obv_narrow | ( | ptr_arith_t | type_id | ) | `[virtual]`

ACE_INLINE const char * CORBA_AbstractBase::_tao_obv_repository_id | ( | void |  | ) | const`[virtual]`

void * CORBA_AbstractBase::_tao_QueryInterface | ( | ptr_arith_t | type | ) | `[virtual]`

CORBA::ValueBase * CORBA_AbstractBase::_tao_to_value | ( | void |  | ) | `[private, virtual]`

CORBA::Boolean CORBA_AbstractBase::_tao_unmarshal_v | ( | TAO_InputCDR & | strm | ) | `[virtual]`

CORBA::Object_ptr CORBA_AbstractBase::_to_object | ( | void |  | ) |

CORBA::ValueBase * CORBA_AbstractBase::_to_value | ( | void |  | ) |

ACE_INLINE CORBA::AbstractBase_ptr CORBA_AbstractBase::_unchecked_narrow | ( | CORBA::AbstractBase_ptr obj | ACE_ENV_ARG_DECL_NOT_USED | ) | `[static]`

| Same for this one.

CORBA_AbstractBase& CORBA_AbstractBase::operator= | ( | const CORBA_AbstractBase & |  | ) | `[private]`

## Friends And Related Function Documentation

TAO_Export CORBA::Boolean operator<< | ( | TAO_OutputCDR & | strm,
|  | const CORBA_AbstractBase_ptr | abs
| ) | `[friend]`

| So the extraction operator can call the protectec constructor.

TAO_Export CORBA::Boolean operator>> | ( | TAO_InputCDR & | strm,
|  | CORBA_AbstractBase_ptr & | abs
| ) | `[friend]`

## Member Data Documentation

int CORBA_AbstractBase::_tao_class_id = 0`[static]`

TAO_Stub* CORBA_AbstractBase::concrete_stubobj_`[private]`

CORBA::Boolean CORBA_AbstractBase::is_collocated_`[private]`

CORBA::Boolean CORBA_AbstractBase::is_local_`[private]`

CORBA::Boolean CORBA_AbstractBase::is_objref_`[protected]`

CORBA::ULong CORBA_AbstractBase::refcount_`[private]`

| Number of outstanding references to this object.

TAO_SYNCH_MUTEX* CORBA_AbstractBase::refcount_lock_`[private]`

| This lock is only instantiated for unconstrained objects. The reason for this is that locality-constrained objects that do not require reference counting (the default) may be instantiated in the critical path. Note: This assumes that unconstrained objects will not be instantiated in the critical path.

TAO_Abstract_ServantBase* CORBA_AbstractBase::servant_`[private]`

The documentation for this class was generated from the following files:

- AbstractBase.h
- AbstractBase.cpp
- AbstractBase.inl